//RESETDS$ JOB (001),'RESET PO/PS DATASET',                             00010000
//             CLASS=A,MSGCLASS=A,COND=(0,NE)                           00020000
//*-----------------------------------------------------------------*   00030000
//*        INSTALL THE 'RESETDS'  PROGRAM                               00040000
//*-----------------------------------------------------------------*   00050000
//RESETDS$ EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK',                   00060000
//             MAC1='SYS1.AMODGEN'                                      00070000
//ASM.SYSIN DD *                                                        00080000
         MACRO                                                          00001000
&LABEL   #RTN                                                           00002000
.*--------------------------------------------------------------------- 00003000
.*                                                                      00004000
.*       STANDARD RETURN MACRO                                          00005000
.*                                                                      00006000
.*--------------------------------------------------------------------- 00007000
         L     R13,4(R13)         GET BACK CHAIN POINTER                00008000
         ST    R15,16(R13)        SAVE REGISTER 15 (RETCODE)            00009000
         LM    R14,R12,12(R13)    RESTORE CALLERS REGS                  00009100
         BR    R14                RETURN TO CALLER                      00009200
.*--------------------------------------------------------------------- 00009300
.*--------------------------------------------------------------------- 00009400
.*                                                                      00009500
.*       FREEWARE: THIS MACRO IS DISTRIBUTED ON AN AS-IS BASIS          00009600
.*                 WITHOUT WARRANTY, EITHER EXPRESSED OR IMPLIED, BY:   00009700
.*                                                                      00009800
.*                 THE NATIONAL SYSTEMS PROGRAMMERS ASSOCIATION (NASPA) 00009900
.*                 P.O. BOX 21525                                       00010000
.*                 GREENFIELD, WI 53221                                 00010100
.*                                                                      00010200
.*                                                                      00010300
.*       MACRO WRITTEN BY:                                              00010400
.*                                                                      00010500
.*                 MILWAUKEE AREA MVS USER GROUP                        00010600
.*                 MILWAUKEE, WI                                        00010700
.*                                                                      00010800
.*--------------------------------------------------------------------- 00010900
.*                                                                      00011000
.*    THIS MACRO HAS MET A BASIC SET OF PROGRAMMING AND                 00011100
.*    DOCUMENTATION STANDARDS, BUT HAS NOT BEEN PROGRAM TESTED IN ANY   00011200
.*    FORMAL FASHION BY NASPA. THE USER IS EXPECTED TO MAKE THE FINAL   00011300
.*    EVALUATION OF THE USE OF THIS MACRO IN THEIR ENVIRONMENT.         00011400
.*                                                                      00011500
.*    NASPA MAKES NO WARRANTY, EXPRESSED OR IMPLIED, OF THE FITNESS     00011600
.*    FOR A PARTICULAR PURPOSE AS RELATES TO THE DOCUMENTATION,         00011700
.*    FUNCTION, RESULTS, OR PERFORMANCE OF THIS MACRO.                  00011800
.*                                                                      00011900
.*    IMPLEMENTATION AND USE OF THIS MACRO CONSTITUTES A RELEASE        00012000
.*    FROM LIABILITY OF NASPA FOR ANY PROBLEMS ARISING FROM THE USE OF  00012100
.*    THIS MACRO AT THE USER'S INSTALLATION.                            00012200
.*                                                                      00012300
.*    THIS MACRO IS MADE AVAILABLE BY NASPA WITHOUT CHARGE.             00012400
.*    RECIPIENTS ARE FREE TO MAKE THIS MACRO AVAILABLE TO OTHERS IN     00012500
.*    LIKE MANNER, PROVIDED THIS DISCLAIMER IS KEPT INTACT.  IT MAY     00012600
.*    NOT BE SOLD, TRADED, OR EXCHANGED FOR CASH, SERVICES, OR AS AN    00012700
.*    INCENTIVE FOR SERVICES AND/OR OTHER PURCHASES, NOR MAY IT BE      00012800
.*    INTEGRATED INTO ANY PROGRAM FOR SUCH USE.                         00012900
.*                                                                      00013000
.*--------------------------------------------------------------------- 00013100
.*--------------------------------------------------------------------- 00013200
         MEND                                                           00013300
         MACRO                                                          00013400
&LABEL   #SLC                                                           00013500
.*--------------------------------------------------------------------- 00013600
.*                                                                      00013700
.*       STANDARD LINKAGE MACRO                                         00013800
.*                                                                      00013900
.*--------------------------------------------------------------------- 00014000
         LCLA  &AA,&BB,&CC                                              00014100
&AA      SETA  1                                                        00014200
&LABEL   CSECT                                                          00014300
         SAVE  (14,12),,'&LABEL &SYSPARM &SYSDATE &SYSTIME '            00014400
         USING &LABEL,&SYSLIST(1)  INFORM ASSEMBLER                     00014500
         LR    &SYSLIST(1),R15    SET BASE                              00014600
         LA    R1,SAVEAREA                                              00014700
         B     START                                                    00014800
SAVEAREA DC    18F'0'                                                   00014900
START    EQU   *                                                        00015000
         ST    R13,4(R1)           SAVE BACK CHAIN                      00015100
         ST    R1,8(R13)           SET FORWARD CHAIN                    00015200
         L     R1,24(R13)          RESTORE REG 1                        00015300
         LA    R13,SAVEAREA        SET SAVEAREA POINTER                 00015400
.LOOP    ANOP                                                           00015500
&AA      SETA  &AA+1                                                    00015600
&CC      SETA  &CC+4096                                                 00015700
         AIF   (&AA GT N'&SYSLIST).DONE                                 00015800
&BB      SETA  &AA-1                                                    00015900
         USING &LABEL+&CC,&SYSLIST(&AA) INFORM ASSEMBLER                00016000
         LA    &SYSLIST(&AA),2048(&SYSLIST(&BB))  LOAD NEXT BASE REG    00016100
         LA    &SYSLIST(&AA),2048(&SYSLIST(&AA))  LOAD NEXT BASE REG    00016200
         AGO   .LOOP                                                    00016300
.DONE    ANOP                                                           00016400
R0       EQU   0                                                        00016500
R1       EQU   1                                                        00016600
R2       EQU   2                                                        00016700
R3       EQU   3                                                        00016800
R4       EQU   4                                                        00016900
R5       EQU   5                                                        00017000
R6       EQU   6                                                        00017100
R7       EQU   7                                                        00017200
R8       EQU   8                                                        00017300
R9       EQU   9                                                        00017400
R10      EQU   10                                                       00017500
R11      EQU   11                                                       00017600
R12      EQU   12                                                       00017700
R13      EQU   13                                                       00017800
R14      EQU   14                                                       00017900
R15      EQU   15                                                       00018000
.*--------------------------------------------------------------------- 00018100
.*--------------------------------------------------------------------- 00018200
.*                                                                      00018300
.*       FREEWARE: THIS MACRO IS DISTRIBUTED ON AN AS-IS BASIS          00018400
.*                 WITHOUT WARRANTY, EITHER EXPRESSED OR IMPLIED, BY:   00018500
.*                                                                      00018600
.*                 THE NATIONAL SYSTEMS PROGRAMMERS ASSOCIATION (NASPA) 00018700
.*                 P.O. BOX 21525                                       00018800
.*                 GREENFIELD, WI 53221                                 00018900
.*                                                                      00019000
.*                                                                      00019100
.*       MACRO WRITTEN BY:                                              00019200
.*                                                                      00019300
.*                 MILWAUKEE AREA MVS USER GROUP                        00019400
.*                 MILWAUKEE, WI                                        00019500
.*                                                                      00019600
.*--------------------------------------------------------------------- 00019700
.*                                                                      00019800
.*    THIS MACRO HAS MET A BASIC SET OF PROGRAMMING AND                 00019900
.*    DOCUMENTATION STANDARDS, BUT HAS NOT BEEN PROGRAM TESTED IN ANY   00020000
.*    FORMAL FASHION BY NASPA. THE USER IS EXPECTED TO MAKE THE FINAL   00020100
.*    EVALUATION OF THE USE OF THIS MACRO IN THEIR ENVIRONMENT.         00020200
.*                                                                      00020300
.*    NASPA MAKES NO WARRANTY, EXPRESSED OR IMPLIED, OF THE FITNESS     00020400
.*    FOR A PARTICULAR PURPOSE AS RELATES TO THE DOCUMENTATION,         00020500
.*    FUNCTION, RESULTS, OR PERFORMANCE OF THIS MACRO.                  00020600
.*                                                                      00020700
.*    IMPLEMENTATION AND USE OF THIS MACRO CONSTITUTES A RELEASE        00020800
.*    FROM LIABILITY OF NASPA FOR ANY PROBLEMS ARISING FROM THE USE OF  00020900
.*    THIS MACRO AT THE USER'S INSTALLATION.                            00021000
.*                                                                      00021100
.*    THIS MACRO IS MADE AVAILABLE BY NASPA WITHOUT CHARGE.             00021200
.*    RECIPIENTS ARE FREE TO MAKE THIS MACRO AVAILABLE TO OTHERS IN     00021300
.*    LIKE MANNER, PROVIDED THIS DISCLAIMER IS KEPT INTACT.  IT MAY     00021400
.*    NOT BE SOLD, TRADED, OR EXCHANGED FOR CASH, SERVICES, OR AS AN    00021500
.*    INCENTIVE FOR SERVICES AND/OR OTHER PURCHASES, NOR MAY IT BE      00021600
.*    INTEGRATED INTO ANY PROGRAM FOR SUCH USE.                         00021700
.*                                                                      00021800
.*--------------------------------------------------------------------- 00021900
.*--------------------------------------------------------------------- 00022000
         MEND                                                           00022100
*---------------------------------------------------------------------- 00022200
*---------------------------------------------------------------------- 00023000
*                                                                       00030000
*        FREEWARE: THIS PROGRAM IS DISTRIBUTED ON AN AS-IS BASIS        00040000
*                  WITHOUT WARRANTY, EITHER EXPRESSED OR IMPLIED, BY:   00050000
*                                                                       00060000
*                  THE NATIONAL SYSTEMS PROGRAMMERS ASSOCIATION (NASPA) 00070000
*                  P.O. BOX 21525                                       00080000
*                  GREENFIELD, WI 53221                                 00090000
*                                                                       00100000
*                                                                       00110000
*        PROGRAM WRITTEN BY:                                            00120000
*                                                                       00130000
*                  ORIGINAL AUTHOR UNKNOWN                              00140000
*                                                                       00150000
*---------------------------------------------------------------------- 00160000
*                                                                       00170000
*     THIS PROGRAM HAS MET A BASIC SET OF PROGRAMMING AND               00180000
*     DOCUMENTATION STANDARDS, BUT HAS NOT BEEN PROGRAM TESTED IN ANY   00190000
*     FORMAL FASHION BY NASPA. THE USER IS EXPECTED TO MAKE THE FINAL   00200000
*     EVALUATION OF THE USE OF THIS PROGRAM IN THEIR ENVIRONMENT.       00210000
*                                                                       00220000
*     NASPA MAKES NO WARRANTY, EXPRESSED OR IMPLIED, OF THE FITNESS     00230000
*     FOR A PARTICULAR PURPOSE AS RELATES TO THE DOCUMENTATION,         00240000
*     FUNCTION, RESULTS, OR PERFORMANCE OF THIS PROGRAM.                00250000
*                                                                       00260000
*     IMPLEMENTATION AND USE OF THIS PROGRAM CONSTITUTES A RELEASE      00270000
*     FROM LIABILITY OF NASPA FOR ANY PROBLEMS ARISING FROM THE USE OF  00280000
*     THIS PROGRAM AT THE USER'S INSTALLATION.                          00290000
*                                                                       00300000
*     THIS PROGRAM IS MADE AVAILABLE BY NASPA WITHOUT CHARGE.           00310000
*     RECIPIENTS ARE FREE TO MAKE THIS PROGRAM AVAILABLE TO OTHERS IN   00320000
*     LIKE MANNER, PROVIDED THIS DISCLAIMER IS KEPT INTACT.  IT MAY     00330000
*     NOT BE SOLD, TRADED, OR EXCHANGED FOR CASH, SERVICES, OR AS AN    00340000
*     INCENTIVE FOR SERVICES AND/OR OTHER PURCHASES, NOR MAY IT BE      00350000
*     INTEGRATED INTO ANY PROGRAM FOR SUCH USE.                         00360000
*                                                                       00370000
*---------------------------------------------------------------------- 00380000
*---------------------------------------------------------------------- 00390000
*********************************************************************** 00400000
*                                                                     * 00410000
*        THIS BATCH UTILITY WILL RESET (EMPTY) PARTITIONED OR         * 00420000
*        SEQUENTIAL DATASETS IN PREPARATION FOR A RELOAD.             * 00430000
*        THE RESULTANT DATASET WILL APPEAR AS THOUGH IT HAD BEEN      * 00440000
*        SCRATCHED AND RE-ALLOCATED, HOWEVER, THE OVERHEAD OF         * 00450000
*        SCRATCH/ALLOCATE AND UNCATALOG/CATALOG IS AVOIDED.           * 00460000
*        ADDITIONALLY, THE DATASET RESET WILL RESIDE IN THE           * 00470000
*        ORIGINAL LOCATION ON THE VOLUME (NOT THE CASE WITH           * 00480000
*        DELETE & RE-ALLOCATED).  THIS ALLOWS FOR PERMANENT           * 00490000
*        PLACEMENT OF DATASETS EVEN THOUGH THEY MAY BE RELOADED.      * 00500000
*                                                                     * 00510000
*        FOR EACH DATASET TO BE RESET, A 'RESET...' DD CARD MUST      * 00520000
*        BE PLACED IN THE JOB STEP (THE ABOVE PERIODS CAN BE ANY      * 00530000
*        CHARATERS SINCE ONLY THE FIRST FIVE ARE CHECKED) AS FOLLOWS: * 00540000
*                                                                     * 00550000
*        //JOBNAME  JOB  (ACCT),PGMRNAME,CLASS=A                      * 00560000
*        //RESET    EXEC PGM=RESETDS                                  * 00570000
*        //RESET1   DD   DISP=OLD,DSN=PDS.DATASET1                    * 00580000
*        //RESETSEQ DD   DISP=OLD,DSN=SEQ.DATASET                     * 00590000
*        //RESET02  DD   DISP=OLD,DSN=PDS.DATASET2                    * 00600000
*        //RESET003 DD   DISP=OLD,DSN=PDS.DATASET3                    * 00610000
*                                                                     * 00620000
*        PARM INFORMATION IS NOT REQUIRED                             * 00630000
*                                                                     * 00640000
*        ATTRIBUTES: NON-REENT NON-AUTH                               * 00650000
*                                                                     * 00660000
*        NOTE: THIS ROUTINE USES THE 'TRKCALC' MACRO WHICH            * 00670000
*        IS ONLY AVAILABLE WITH DFS SUPPORT.                          * 00680000
*                                                                     * 00690000
*********************************************************************** 00700000
         EJECT                                                          00710000
RESETDS  #SLC  R12                                                      00720000
         L     R1,16               GET CVT POINTER                      00730000
         L     R1,0(R1)            OLD/NEW POINTER                      00740000
         L     R1,4(R1)            OUR TCB POINTER                      00750000
         L     R10,12(R1)          OUR TIOT POINTER                     00760000
         A     R10,=F'24'          BUMP TO FIRST DD ENTRY               00770000
NEXTENT  DS    0H                                                       00780000
         CLI   0(R10),X'00'        END OF TIOT?                         00790000
         BE    EXIT                YES, ALL DONE                        00800000
         CLC   4(5,R10),=CL5'RESET' IS THIS A TARGET DATASET?           00810000
         BE    PROCESS             YES, PROCESS IT                      00820000
NEXTDD   DS    0H                                                       00830000
         SR    R0,R0               CLEAR FOR IC                         00840000
         IC    R0,0(R10)           GET ENTRY SIZE                       00850000
         AR    R10,R0              BUMP TO NEXT ENTRY                   00860000
         B     NEXTENT             PROCESS NEXT ENTRY                   00870000
         EJECT                                                          00880000
*                                                                       00890000
*        A RESET... DD HAS BEEN FOUND, IF SEQUENTIAL, RESET IT          00900000
*        THROUGH AN OPEN/CLOSE SEQUENCE                                 00910000
*                                                                       00920000
PROCESS  DS    0H                                                       00930000
         MVC   DCBSEQ+DCBDDNAM-IHADCB(8),4(R10) MOVE DDNAME TO DCB      00940000
         RDJFCB DCBSEQ             GET THE JFCB                         00950000
         MVC   VOLSER,JFCBVOLS     MOVE THE VOLSER FOR OBTAIN           00960000
         OBTAIN CAMLST             READ IN THE FORMAT1 DSCB             00970000
         LTR   R15,R15             DID IT WORK?                         00980000
         BNZ   ERR1                NO, EXIT AS ERROR                    00990000
         CLI   DS1DSORG,DS1DSGPS   IS THIS A SEQUENTIAL DATASET?        01000000
         BNE   CHECKPDS            NO, CHECK PDS THEN                   01010000
         OPEN  (DCBSEQ,(OUTPUT))   OPEN THE FILE TO RESET IT            01020000
         CLOSE DCBSEQ              AND CLOSE IT                         01030000
         B     NEXTDD              PROCESS NEXT ENTRY                   01040000
         EJECT                                                          01050000
*                                                                       01060000
*        IF THE ENTRY IS A PDS:                                         01070000
*        1)  READ THE FIRST PDS DIRECTORY BLOCK (USING BSAM)            01080000
*        2)  RE-WRITE SAME AS AN EMPTY BLOCK (USING EXCP)               01090000
*        3)  READ (SKIP) THE REMAINING DIRECTORY BLOCKS                 01100000
*            (THIS ALLOWS US TO DETERMINE THE LAST RECORD               01110000
*            OF THE DIRECTORY)                                          01120000
*        4)  CALCULATE THE TRACK BALANCE (USING TRKCALC MACRO)          01130000
*        5)  UPDATE THE EXCP DCB WITH TO REFLECT NEXT AVAILABLE         01140000
*            TRACK AND TRACK BALANCE                                    01150000
*        6)  CLOSE THE TWO DCBS (THE EXCP DCB CLOSE CAUSES THE          01160000
*            DSCB LSTAR FIELD(S) TO BE UPDATED)                         01170000
*                                                                       01180000
CHECKPDS DS    0H                                                       01190000
         CLI   DS1DSORG,DS1DSGPO IS THIS A PARTITIONED DATASET?         01200000
         BNE   ERR3                NO, INVALID REQUEST                  01210000
         MVC   DCBBSAM+DCBDDNAM-IHADCB(8),4(R10) MOVE DDN TO BSAM DCB   01220000
         MVC   DCBEXCP+DCBDDNAM-IHADCB(8),4(R10) MOVE DDN TO EXCP DCB   01230000
         OPEN  (DCBBSAM,(INPUT),DCBEXCP,(OUTPUT))                       01240000
         TM    DCBEXCP+DCBOFLGS-IHADCB,DCBOFOPN DID IT OPEN?            01250000
         BZ    ERR4                NO, OPEN FAILED                      01260000
         TM    DCBBSAM+DCBOFLGS-IHADCB,DCBOFOPN DID IT OPEN?            01270000
         BZ    ERR4                NO, OPEN FAILED                      01280000
         READ  DECB1,SF,DCBBSAM,BUFFER,'S' READ THE FIRST DIR BLOCK     01290000
         CHECK DECB1               WAIT FOR COMPLETION                  01300000
         MVC   MBBCCHHR(8),DCBBSAM+DCBFDAD-IHADCB COPY DISK ADDRESS     01310000
         XC    ECB,ECB             CLEAR ECB                            01320000
         EXCP  IOB                 UPDATE THE FIRST DIRECTORY BLOCK     01330000
         WAIT  ECB=ECB             WAIT FOR COMPLETION                  01340000
         CLI   ECB,X'7F'           VALID COMPLETION?                    01350000
         BNE   ERR5                NO, INFORM USER                      01360000
LOOP     READ  DECB2,SF,DCBBSAM,BUFFER,'S' READ (SKIP) THE REMAINING    01370000
         CHECK DECB2               WAIT FOR COMPLETION                  01380000
         B     LOOP                LOOP UNTIL END OF FILE               01390000
         EJECT                                                          01400000
*                                                                       01410000
*        CALCULATE THE SPACE REMAINING ON THE CURRENT (LAST) TRACK      01420000
*        TO PROVIDE A BASE FOR THE NEXT TRKCALC FUNCTION.               01430000
*                                                                       01440000
EODAD    DS    0H                  O.K! NOW HAVE DISK ADDR OF LAST REC  01450000
         SR    R2,R2               CLEAR FOR IC                         01460000
         IC    R2,DCBBSAM+DCBFDAD+7-IHADCB GET REC # OF FILE MARK       01470000
         BCTR  R2,R0               DECREMENT FOR FILE MARK              01480000
         SR    R3,R3               CLEAR FOR ICM                        01490000
         ICM   R3,7,17(R10)        TIOT ENTRY UCB POINTER               01500000
         TRKCALC FUNCTN=TRKBAL,UCB=(R3),REGSAVE=YES,MF=(E,TRKCALC),    *01510000
               R=(R2),K=8,DD=256   CALCULATE CURRENT TRACK BALANCE      01520000
         LA    R2,1(R2)            INCRMENT FOR FILE MARK               01530000
*                                                                       01540000
*        CALCULATE THE SPACE REMAINING ON THE CURRENT (LAST) TRACK      01550000
*        FOLLOWING THE FILE MARK.                                       01560000
*                                                                       01570000
         TRKCALC FUNCTN=TRKBAL,UCB=(R3),REGSAVE=YES,MF=(E,TRKCALC),    *01580000
               BALANCE=STARBAL,                                        *01590000
               R=(R2),K=0,DD=0     CALCULATE BALANCE AFTER EOF          01600000
         STCM  R0,3,DCBEXCP+DCBTRBAL-IHADCB AND UPDATE THE EXCP DCB     01610000
         MVC   DCBEXCP+DCBFDAD-IHADCB(8),DCBBSAM+DCBFDAD-IHADCB         01620000
         CLOSE (DCBBSAM,,DCBEXCP)  CLOSE THE FILES (UPDATE DSCLSTAR)    01630000
         B     NEXTDD              PROCESS NEXT ENTRY                   01640000
EXIT     DS    0H                                                       01650000
         L     R15,RC              GET FINAL RETURN CODE                01660000
         #RTN                                                           01670000
         EJECT                                                          01680000
*                                                                       01690000
*        ERROR PROCESSING ROUTINE                                       01700000
*                                                                       01710000
ERR1     MVC   WTO1+17(32),=CL32'OBTAIN FAILED FOR'                     01720000
         B     ERR0                 TO COMMON CODE                      01730000
ERR2     MVC   WTO1+17(32),=CL32'OPEN FAILED FOR SEQ DCB'               01740000
         B     ERR0                 TO COMMON CODE                      01750000
ERR3     MVC   WTO1+17(32),=CL32'INVALID DSORG'                         01760000
         B     ERR0                 TO COMMON CODE                      01770000
ERR4     MVC   WTO1+17(32),=CL32'OPEN FAILED FOR PDS DCB'               01780000
         B     ERR0                 TO COMMON CODE                      01790000
ERR5     MVC   WTO1+17(32),=CL32'EXCP FAILED'                           01800000
         B     ERR0                 TO COMMON CODE                      01810000
ERR0     MVC   WTO2+17(44),JFCB     MOVE DSNAME TO MESSAGE              01820000
WTO1     WTO  'RESETDS:                                    ',          *01830000
               ROUTCDE=11                                               01840000
WTO2     WTO  'RESETDS:                                              ',*01850000
               ROUTCDE=11                                               01860000
         MVI   RC+3,12              SET RETURN CODE                     01870000
         B     NEXTDD               PROCESS NEXT DD IF POSSIBLE         01880000
         EJECT                                                          01890000
*                                                                     * 01900000
*        CONSTANTS:  MOST ARE ORDER DEPENDENET SO BE CAREFUL          * 01910000
*                                                                     * 01920000
*        THE FOLLOWING ARE ORDER DEPENDENT                              01930000
         DS    0D                  DOUBLE WORD ALIGN                    01940000
DSCB     DS    265C                DSCB WORK AREA                       01950000
         PRINT OFF                                                      01960000
         ORG   DSCB-44             (ONLY 96 BYTES READ BY OBTAIN)       01970000
         IECSDSL1 (1)              DSCB MAPPING MACRO                   01980000
         PRINT ON                                                       01990000
         ORG                                                            02000000
VOLSER   DC    CL6' '              VOLSER FOR OBTAIN                    02010000
KEY      DC    8X'FF'              KEY FIELD                            02020000
DATA     DC    X'000E'             BYTES USED IN DIRECTORY BLOCK        02030000
         DC    8X'FF',246X'00'     ENDING FENCE AND DATA                02040000
CCW1     CCW   X'31',CCHHR,X'40',5 SEARCH-ID                            02050000
CCW2     CCW   X'08',CCW1,0,0      TIC                                  02060000
CCW3     CCW   X'0D',KEY,0,264     WRITE KEY & DATA                     02070000
IOB      DC    0D'0'               *****                                02080000
         DC    X'42'               *                                    02090000
         DC    XL4'0'              *                                    02100000
         DC    AL3(ECB)            * EXCP'S                             02110000
         DC    2A(0) CSW           *  IOB                               02120000
         DC    A(CCW1)             *                                    02130000
         DC    A(DCBEXCP)          *                                    02140000
         DC    2A(0)               *                                    02150000
MBBCCHHR DC    XL3'000000'         *                                    02160000
CCHHR    DC    XL5'00000000'       *****                                02170000
*        END OF ORDER DEPENDENCE                                        02180000
*                                                                       02190000
         DS    0D                  DOUBLEWORD ALIGNMENT                 02200000
CAMLST   CAMLST SEARCH,JFCB,VOLSER,DSCB  TO READ THE FORMAT 1 DSCB      02210000
BUFFER   DC    CL256' '            BSAM READ BUFFER                     02220000
RC       DC    A(0)                FINAL RETURN CODE                    02230000
ECB      DC    F'0'                EXCP ECB                             02240000
OPENLIST DC    X'87',AL3(JFCB)     JFCB ADDR FOR SEQ DCB                02250000
JFCB     DC    XL176'00'           JFCB AREA                            02260000
         ORG   JFCB                                                     02270000
         PRINT OFF                                                      02280000
         IEFJFCBN                  DSECT FOR JFCB                       02290000
         PRINT ON                                                       02300000
         ORG                                                            02310000
DCBSEQ   DCB   DDNAME=DUMMY,DSORG=PS,MACRF=W,EXLST=OPENLIST             02320000
DCBBSAM  DCB   DDNAME=JUNK,DSORG=PS,MACRF=R,EODAD=EODAD,               *02330000
               LRECL=256,BLKSIZE=256,RECFM=F                            02340000
DCBEXCP  DCB   DDNAME=JUNK,DSORG=PS,MACRF=E,KEYLEN=8,DEVD=DA            02350000
         LTORG                                                          02360000
TRKCALC  TRKCALC MF=L              TRKCALC PARAMETER LIST               02370000
         ORG   TRKCALC             PROVIDE LABELS FOR TRKCALC           02380000
         PRINT OFF                                                      02390000
         TRKCALC MF=D              TRKCALC DSECT                        02400000
         ORG                                                            02410000
         DCBD  DSORG=PS,DEVD=DA                                         02420000
         END                                                            02430000
//LKED.SYSLMOD DD DSN=SYS2.LINKLIB,DISP=SHR                             00100000
//SYSIN DD *                                                            00110000
 NAME RESETDS(R)                                                        00120000
//                                                                      00130000
